from strictyaml.ruamel.tokens import *
from _typeshed import Incomplete
from strictyaml.ruamel.error import MarkedYAMLError
from typing import Any, Optional, Text

class ScannerError(MarkedYAMLError): ...

class SimpleKey:
    token_number: Incomplete
    required: Incomplete
    index: Incomplete
    line: Incomplete
    column: Incomplete
    mark: Incomplete
    def __init__(
        self,
        token_number: Any,
        required: Any,
        index: int,
        line: int,
        column: int,
        mark: Any,
    ) -> None: ...

class Scanner:
    loader: Incomplete
    first_time: bool
    yaml_version: Incomplete
    def __init__(self, loader: Any = ...) -> None: ...
    @property
    def flow_level(self) -> int: ...
    done: bool
    flow_context: Incomplete
    tokens: Incomplete
    tokens_taken: int
    indent: int
    indents: Incomplete
    allow_simple_key: bool
    possible_simple_keys: Incomplete
    def reset_scanner(self) -> None: ...
    @property
    def reader(self) -> Any: ...
    @property
    def scanner_processing_version(self) -> Any: ...
    def check_token(self, *choices: Any) -> bool: ...
    def peek_token(self) -> Any: ...
    def get_token(self) -> Any: ...
    def need_more_tokens(self) -> bool: ...
    def fetch_comment(self, comment: Any) -> None: ...
    def fetch_more_tokens(self) -> Any: ...
    def next_possible_simple_key(self) -> Any: ...
    def stale_possible_simple_keys(self) -> None: ...
    def save_possible_simple_key(self) -> None: ...
    def remove_possible_simple_key(self) -> None: ...
    def unwind_indent(self, column: Any) -> None: ...
    def add_indent(self, column: int) -> bool: ...
    def fetch_stream_start(self) -> None: ...
    def fetch_stream_end(self) -> None: ...
    def fetch_directive(self) -> None: ...
    def fetch_document_start(self) -> None: ...
    def fetch_document_end(self) -> None: ...
    def fetch_document_indicator(self, TokenClass: Any) -> None: ...
    def fetch_flow_sequence_start(self) -> None: ...
    def fetch_flow_mapping_start(self) -> None: ...
    def fetch_flow_collection_start(self, TokenClass: Any, to_push: Text) -> None: ...
    def fetch_flow_sequence_end(self) -> None: ...
    def fetch_flow_mapping_end(self) -> None: ...
    def fetch_flow_collection_end(self, TokenClass: Any) -> None: ...
    def fetch_flow_entry(self) -> None: ...
    def fetch_block_entry(self) -> None: ...
    def fetch_key(self) -> None: ...
    def fetch_value(self) -> None: ...
    def fetch_alias(self) -> None: ...
    def fetch_anchor(self) -> None: ...
    def fetch_tag(self) -> None: ...
    def fetch_literal(self) -> None: ...
    def fetch_folded(self) -> None: ...
    def fetch_block_scalar(self, style: Any) -> None: ...
    def fetch_single(self) -> None: ...
    def fetch_double(self) -> None: ...
    def fetch_flow_scalar(self, style: Any) -> None: ...
    def fetch_plain(self) -> None: ...
    def check_directive(self) -> Any: ...
    def check_document_start(self) -> Any: ...
    def check_document_end(self) -> Any: ...
    def check_block_entry(self) -> Any: ...
    def check_key(self) -> Any: ...
    def check_value(self) -> Any: ...
    def check_plain(self) -> Any: ...
    def scan_to_next_token(self) -> Any: ...
    def scan_directive(self) -> Any: ...
    def scan_directive_name(self, start_mark: Any) -> Any: ...
    def scan_yaml_directive_value(self, start_mark: Any) -> Any: ...
    def scan_yaml_directive_number(self, start_mark: Any) -> Any: ...
    def scan_tag_directive_value(self, start_mark: Any) -> Any: ...
    def scan_tag_directive_handle(self, start_mark: Any) -> Any: ...
    def scan_tag_directive_prefix(self, start_mark: Any) -> Any: ...
    def scan_directive_ignored_line(self, start_mark: Any) -> None: ...
    def scan_anchor(self, TokenClass: Any) -> Any: ...
    def scan_tag(self) -> Any: ...
    def scan_block_scalar(self, style: Any, rt: Optional[bool] = ...) -> Any: ...
    def scan_block_scalar_indicators(self, start_mark: Any) -> Any: ...
    def scan_block_scalar_ignored_line(self, start_mark: Any) -> Any: ...
    def scan_block_scalar_indentation(self) -> Any: ...
    def scan_block_scalar_breaks(self, indent: int) -> Any: ...
    def scan_flow_scalar(self, style: Any) -> Any: ...
    ESCAPE_REPLACEMENTS: Incomplete
    ESCAPE_CODES: Incomplete
    def scan_flow_scalar_non_spaces(self, double: Any, start_mark: Any) -> Any: ...
    def scan_flow_scalar_spaces(self, double: Any, start_mark: Any) -> Any: ...
    def scan_flow_scalar_breaks(self, double: Any, start_mark: Any) -> Any: ...
    def scan_plain(self) -> Any: ...
    def scan_plain_spaces(self, indent: Any, start_mark: Any) -> Any: ...
    def scan_tag_handle(self, name: Any, start_mark: Any) -> Any: ...
    def scan_tag_uri(self, name: Any, start_mark: Any) -> Any: ...
    def scan_uri_escapes(self, name: Any, start_mark: Any) -> Any: ...
    def scan_line_break(self) -> Any: ...

class RoundTripScanner(Scanner):
    def check_token(self, *choices: Any) -> bool: ...
    def peek_token(self) -> Any: ...
    def get_token(self) -> Any: ...
    def fetch_comment(self, comment: Any) -> None: ...
    allow_simple_key: bool
    def scan_to_next_token(self) -> Any: ...
    def scan_line_break(self, empty_line: bool = ...) -> Text: ...
    def scan_block_scalar(self, style: Any, rt: Optional[bool] = ...) -> Any: ...
